import numpy as np
import plotly.graph_objs as go
from scipy import signal

# variables
c = 300000000 # lightspeed in [m/s]
z = np.linspace(-6e-07,3.6e-06,700) # x-axis in [m]
z_norm = np.linspace(0,1,500) # normalized and pruned x-axis
delta_t = 6e-17 # delta between two frames


def cosn(z,t,k,w):
    k = np.transpose([k])
    w = np.transpose([w])
    return np.cos(k*z-w*t)

def cosn_phs(z,t,k,w):
    '''position of the phase velocity pointer'''
    return 2*np.cos(((np.max(w)+np.min(w))*t-(np.max(k)+np.min(k))*z)/2)

def cosn_grp(z,t,k,w):
    '''position of the group velocity pointer'''
    return 2*np.cos(((np.max(w)-np.min(w))*t-(np.max(k)-np.min(k))*z)/2)

def generate_figure(F_ph,F_gr,n_intervals,frequencies,n_f,speed):
    '''
    Generation of two figures:
    ->plot of impulse, envelope, carrier frequency, phase velocity pointer and group velocity pointer
    ->plot of basic frequencies

    Args:
        F_ph (int): factor of phase velocity
        F_gr (int): factor of group velocity
        n_intervals (int): frame number (generated by dcc.interval function in applayout.py)
        freqeuencies (list): 10x2 list with all frequencies and their respective phase offset
        n_f (int): number of currently used basic frequencies
        speed (int): animation speed

    Returns:
        fig1 (object): go.Figure object with a plot of impulse, envelope, carrier frequency, phase velocity pointer and group velocity pointer
        fig2 (object): go.Figure object with a plot of basic frequencies

    '''

    if np.all(frequencies) is None: # catch errors if one frequency or phase input is invalid
        return go.Figure(), go.Figure()

    t = delta_t*n_intervals*speed
    frequencies = np.array(frequencies) # create numpy array
    lam = c/(np.array(frequencies[0][:n_f])*1e14) # convert frequencies to lambdas
    lam_avg = np.average(lam)

    # calculate k and weigh with kind of refractive index
    # (1/F_ph) influences the phase velocity v_ph = w/k
    # (F_gr-F_ph)*(lam-lam_avg)*1e06 influences the group velocity v_gr = dw/dk
    k = ((1/F_ph)+(F_gr-F_ph)*(lam-lam_avg)*1e06)*2*np.pi/lam
    # calculate w
    w = 2*np.pi*c/lam

    # position of group velocity
    if np.max(w) != np.min(w):
        z_grp = ((np.max(w)-np.min(w))/(np.max(k)-np.min(k)))*t
    else:
        z_grp = np.max(w)/np.max(k)*t
    
    # position of phase velocity
    z_phs = ((np.max(w)+np.min(w))/(np.max(k)+np.min(k)))*t

    # convert phase offset in x-axis offset
    offset = np.transpose([lam*frequencies[1,:n_f]/360])

    cosn_h = cosn(z+offset,t,k,w) # array with all frequencies to plot
    cosn_h_cut = cosn_h[:,100:601] # pruned array to mitigate effects of Hilbert-transform

    # data array for fig1
    data1=[go.Scatter(x=z_norm,y=np.sum(cosn_h_cut,0),mode="lines",line=dict(width=2, color="orange"),name='Impuls', opacity=1),
            go.Scatter(x=np.append(np.append(z_norm,[np.nan]),z_norm),y=np.append(np.append(np.abs(signal.hilbert(np.sum(cosn_h,0))[100:601]),[np.nan]),-np.abs(signal.hilbert(np.sum(cosn_h,0))[100:601])),mode="lines",line=dict(width=2, color="blue"),name='Einhüllende', opacity=1),
            go.Scatter(x=z_norm,y=cosn(z,t,(1/F_ph)*2*np.pi/lam_avg,2*np.pi*c/lam_avg)[100:601],mode="lines",line=dict(width=2, color="darkviolet"),name='Trägerschwingung', opacity=1,visible='legendonly'),
            go.Scatter(x=[z_grp/3e-06],y=np.sum(cosn(z_grp+offset,t,k,w),0),mode="markers",marker=dict(size=10, color="green"),name='Gruppengeschwindigkeit', opacity=1),
            go.Scatter(x=[z_phs/3e-06],y=np.sum(cosn(z_phs+offset,t,k,w),0),mode="markers",marker=dict(size=10, color="red"),name='Phasengeschwindigkeit', opacity=1),
            ]

    # layout for fig1
    fig1 = go.Figure(
            data=data1,
            layout=go.Layout(
                        xaxis=dict(range=[z_norm[0], z_norm[-1]], autorange=False, zeroline=False),
                        yaxis=dict(range=[-lam.size-0.5, lam.size+0.5], autorange=False, zeroline=False), 
                        hovermode="closest",
                        legend=dict(orientation="h", yanchor="bottom", y=1.02, xanchor="right", x=1, font=dict(size=15,),)
                    )
            )

    # data array for fig2 (length depends on frequencies currently shown)
    data2 = []
    for i in range(lam.size):
        data2.append(go.Scatter(x=z_norm,y=cosn_h_cut[i],mode="lines",line=dict(width=2),name='E'+str(i+1), opacity=1))

    # layout for fig2
    fig2 = go.Figure(
            data=data2,
            layout=go.Layout(
                xaxis=dict(range=[z_norm[0], z_norm[-1]], autorange=False, zeroline=False),
                yaxis=dict(range=[-1.2, 1.2], autorange=False, zeroline=False), 
                hovermode="closest",
                legend=dict(orientation="h", yanchor="bottom", y=1.02, xanchor="right", x=1, font=dict(size=15,),)
                    )
            )

    fig1.update_layout(uirevision='constant') # prevents settings to be changed if reset button is pressed
    fig2.update_layout(uirevision='constant')

    return fig1,fig2